/* myinfo.h */

struct txt {
  struct txt *next;
  char *txt;
};

/* my_struct.flags */
#define DO_ERRORLOG  (ULONG) 0x000001
#define DO_SYSOPLOG  (ULONG) 0x000002
#define VALID_USER   (ULONG) 0x000010

#define MAX_SAYINGS 50

struct rndsay {
  char *saying[MAX_SAYINGS+1];          /* text to show */
  UBYTE rnum;                            /* num of random sayings */
  UBYTE type;
};


struct myst {
 long zoom_mailcnt;            /* num msgs of mail zoomed */
 char *zoom_mailfile;       /* path & name of created zoom file */
 char *zoom_path;             /* our defined path for zoom mail */
 long maxdbytes;             /* max download bytes per session, anyone */
 long sessiondbytes;         /* current user dnloaded bytes per session */
 int newuser;
 long times_on;              /* Times on system */
 int AnsiColor;
 char *startchatfile;        /* the file itsself */
 char *stopchatfile;         /* the file itsself */
 char *quotefile;
 int startchatnum;           /* number of sayings in file */
 int  stopchatnum;           /* number of lines in the file */
 int quotenum;               /* number of quotes */
 int numlastcallers;         /* number of last callers to display */
 USHORT lastcallerlevel;        /* min level to display last callers log */
 struct txt *callerlist;        /* also for callers list */
 char *newuserfile;          /* path:filename of the new user must read file */
 int max_desclines;          /* Max number of lines in file descriptions */
 UWORD UPcps;                /* highest uploaded cps rate */
 UWORD DNcps;                /* highest dnload cps rate */
 char *UPcps_name;           /* highest upload cps rate users name */
 char *UPcps_place;          /* where user is from */
 char *DNcps_name;           /* highest dnload cps rate users name */
 char *DNcps_place;          /* where user is from */
 ULONG flags;                /* program options flag */
 UBYTE cosysop_level;        /* cosysop level */
 char *countryname;          /* country name where bbs is run */
 char *notallowedfiles;      /* ptr to files not allowed list */
 char *skiplcaller;          /* skip lastcallers, users in this list don't show */
 struct rndsay *menu_say;    /* random things to display in the menu */
 UBYTE nozoom[MAX_CONFS];    /* don't zoom these conferences */
 int   zoommax;              /* max number of zoom msgs outputted */
 /* add struct txt *no2400  or set up a filesize no 2400 can see */
 /* like dir1 .. then add other places to search for duplicates */
};

/*--- User.Keys UserFlags */
#define USER_NEWMSG       (UWORD) 0x0001     /* show new user message */
#define USER_TOCONF1      (UWORD) 0x0002
#define USER_ONETIME_MSG  (UWORD) 0x0004     /* show all users only once */
#define USER_SCRNCLR      (UWORD) 0x0008
#define USER_DONATED      (UWORD) 0x0010


/* MDate.c flags */
#define TODAY_DATE       (UWORD) 0x0000
#define YESTERDAY_DATE   (UWORD) 0x0001
#define MYTIMEFMT      "%02.2d:%02.2d:%02.2d"
#define MYDATEFMT      "%02.2d-%02.2d-%02.2d"

#define MAX_DATE_STRING  20                     /* xx-xx-xx  */

/* protos */
int check_fordup(char *tx, char *nam);
int show_lastcallers(struct txt *tx,int color);
//int MDate(long *MY_time,char *MY_datestr, char *MY_timestr, UWORD flg);
//void reset_struct(void);
//void center(char *, int);
int find_str(char *search_string, char *txt);
void get_todays_uploads(void);
void StripReturn(char *);
